From 2730f9260c9cc1cb352b86637b72398931401e62 Mon Sep 17 00:00:00 2001
From: Danish Prakash <contact@danishpraka.sh>
Date: Tue, 22 Oct 2024 12:46:17 +0530
Subject: [PATCH 2/5] Use securejoin.SecureJoin when forming userns paths

We need to read /etc/passwd and /etc/group in the container to
get an idea of how many UIDs and GIDs we need to allocate for a
user namespace when `--userns=auto` is specified. We were forming
paths for these using filepath.Join, which is not safe for paths
within a container, resulting in this CVE allowing crafted
symlinks in the container to access paths on the host instead.

* cyphar/filepath-securejoin bump to required 0.3.0

Addresses CVE-2024-9676
Bugs: bsc#1231698

Signed-off-by: Matt Heon <mheon@redhat.com>
Signed-off-by: Danish Prakash <contact@danishpraka.sh>
---
 go.mod                                        |    4 +-
 go.sum                                        |    8 +-
 .../github.com/containers/storage/.cirrus.yml |    2 +-
 .../github.com/containers/storage/userns.go   |   87 +-
 .../containers/storage/userns_unsupported.go  |   14 +
 .../cyphar/filepath-securejoin/LICENSE        |    2 +-
 .../cyphar/filepath-securejoin/README.md      |  139 +-
 .../cyphar/filepath-securejoin/VERSION        |    2 +-
 .../cyphar/filepath-securejoin/join.go        |   85 +-
 .../filepath-securejoin/lookup_linux.go       |  380 ++
 .../cyphar/filepath-securejoin/mkdir_linux.go |  228 +
 .../cyphar/filepath-securejoin/open_linux.go  |   83 +
 .../filepath-securejoin/openat2_linux.go      |  128 +
 .../filepath-securejoin/openat_linux.go       |   59 +
 .../filepath-securejoin/procfs_linux.go       |  481 ++
 .../testing_mocks_linux.go                    |   68 +
 .../cyphar/filepath-securejoin/vfs.go         |    2 +-
 vendor/golang.org/x/sys/cpu/cpu.go            |    1 +
 vendor/golang.org/x/sys/cpu/cpu_arm64.go      |   10 +
 vendor/golang.org/x/sys/cpu/cpu_arm64.s       |    8 +
 vendor/golang.org/x/sys/cpu/cpu_gc_arm64.go   |    1 +
 .../golang.org/x/sys/cpu/cpu_linux_arm64.go   |    5 +
 vendor/golang.org/x/sys/unix/asm_zos_s390x.s  |  665 +-
 vendor/golang.org/x/sys/unix/bpxsvc_zos.go    |  657 ++
 vendor/golang.org/x/sys/unix/bpxsvc_zos.s     |  192 +
 vendor/golang.org/x/sys/unix/epoll_zos.go     |  220 -
 vendor/golang.org/x/sys/unix/fstatfs_zos.go   |  163 -
 vendor/golang.org/x/sys/unix/mkerrors.sh      |    2 +
 vendor/golang.org/x/sys/unix/mmap_nomremap.go |    2 +-
 vendor/golang.org/x/sys/unix/pagesize_unix.go |    2 +-
 .../x/sys/unix/readdirent_getdirentries.go    |    2 +-
 vendor/golang.org/x/sys/unix/sockcmsg_zos.go  |   58 +
 .../golang.org/x/sys/unix/symaddr_zos_s390x.s |   75 +
 .../x/sys/unix/syscall_zos_s390x.go           | 1509 ++++-
 vendor/golang.org/x/sys/unix/sysvshm_unix.go  |    2 +-
 .../x/sys/unix/sysvshm_unix_other.go          |    2 +-
 vendor/golang.org/x/sys/unix/zerrors_linux.go |   29 +-
 .../x/sys/unix/zerrors_linux_386.go           |    1 +
 .../x/sys/unix/zerrors_linux_amd64.go         |    1 +
 .../x/sys/unix/zerrors_linux_arm64.go         |    1 +
 .../x/sys/unix/zerrors_zos_s390x.go           |  233 +-
 .../x/sys/unix/zsymaddr_zos_s390x.s           |  364 ++
 .../x/sys/unix/zsyscall_zos_s390x.go          | 3113 ++++++++--
 .../x/sys/unix/zsysnum_linux_386.go           |    5 +
 .../x/sys/unix/zsysnum_linux_amd64.go         |    5 +
 .../x/sys/unix/zsysnum_linux_arm.go           |    5 +
 .../x/sys/unix/zsysnum_linux_arm64.go         |    5 +
 .../x/sys/unix/zsysnum_linux_loong64.go       |    5 +
 .../x/sys/unix/zsysnum_linux_mips.go          |    5 +
 .../x/sys/unix/zsysnum_linux_mips64.go        |    5 +
 .../x/sys/unix/zsysnum_linux_mips64le.go      |    5 +
 .../x/sys/unix/zsysnum_linux_mipsle.go        |    5 +
 .../x/sys/unix/zsysnum_linux_ppc.go           |    5 +
 .../x/sys/unix/zsysnum_linux_ppc64.go         |    5 +
 .../x/sys/unix/zsysnum_linux_ppc64le.go       |    5 +
 .../x/sys/unix/zsysnum_linux_riscv64.go       |    5 +
 .../x/sys/unix/zsysnum_linux_s390x.go         |    5 +
 .../x/sys/unix/zsysnum_linux_sparc64.go       |    5 +
 .../x/sys/unix/zsysnum_zos_s390x.go           | 5507 +++++++++--------
 vendor/golang.org/x/sys/unix/ztypes_linux.go  |   59 +-
 .../golang.org/x/sys/unix/ztypes_linux_386.go |    8 -
 .../x/sys/unix/ztypes_linux_amd64.go          |    9 -
 .../golang.org/x/sys/unix/ztypes_linux_arm.go |    9 -
 .../x/sys/unix/ztypes_linux_arm64.go          |    9 -
 .../x/sys/unix/ztypes_linux_loong64.go        |    9 -
 .../x/sys/unix/ztypes_linux_mips.go           |    9 -
 .../x/sys/unix/ztypes_linux_mips64.go         |    9 -
 .../x/sys/unix/ztypes_linux_mips64le.go       |    9 -
 .../x/sys/unix/ztypes_linux_mipsle.go         |    9 -
 .../golang.org/x/sys/unix/ztypes_linux_ppc.go |    9 -
 .../x/sys/unix/ztypes_linux_ppc64.go          |    9 -
 .../x/sys/unix/ztypes_linux_ppc64le.go        |    9 -
 .../x/sys/unix/ztypes_linux_riscv64.go        |    9 -
 .../x/sys/unix/ztypes_linux_s390x.go          |    9 -
 .../x/sys/unix/ztypes_linux_sparc64.go        |    9 -
 .../golang.org/x/sys/unix/ztypes_zos_s390x.go |  146 +-
 vendor/golang.org/x/sys/windows/aliases.go    |    2 +-
 vendor/golang.org/x/sys/windows/empty.s       |    8 -
 .../x/sys/windows/security_windows.go         |    1 +
 .../x/sys/windows/syscall_windows.go          |   82 +
 .../golang.org/x/sys/windows/types_windows.go |   24 +
 .../x/sys/windows/zsyscall_windows.go         |  135 +-
 vendor/modules.txt                            |    6 +-
 83 files changed, 10900 insertions(+), 4369 deletions(-)
 create mode 100644 vendor/github.com/containers/storage/userns_unsupported.go
 create mode 100644 vendor/github.com/cyphar/filepath-securejoin/lookup_linux.go
 create mode 100644 vendor/github.com/cyphar/filepath-securejoin/mkdir_linux.go
 create mode 100644 vendor/github.com/cyphar/filepath-securejoin/open_linux.go
 create mode 100644 vendor/github.com/cyphar/filepath-securejoin/openat2_linux.go
 create mode 100644 vendor/github.com/cyphar/filepath-securejoin/openat_linux.go
 create mode 100644 vendor/github.com/cyphar/filepath-securejoin/procfs_linux.go
 create mode 100644 vendor/github.com/cyphar/filepath-securejoin/testing_mocks_linux.go
 create mode 100644 vendor/golang.org/x/sys/unix/bpxsvc_zos.go
 create mode 100644 vendor/golang.org/x/sys/unix/bpxsvc_zos.s
 delete mode 100644 vendor/golang.org/x/sys/unix/epoll_zos.go
 delete mode 100644 vendor/golang.org/x/sys/unix/fstatfs_zos.go
 create mode 100644 vendor/golang.org/x/sys/unix/sockcmsg_zos.go
 create mode 100644 vendor/golang.org/x/sys/unix/symaddr_zos_s390x.s
 create mode 100644 vendor/golang.org/x/sys/unix/zsymaddr_zos_s390x.s
 delete mode 100644 vendor/golang.org/x/sys/windows/empty.s

diff --git a/go.mod b/go.mod
index 67d29132ef67..146e206d926c 100644
--- a/go.mod
+++ b/go.mod
@@ -10,7 +10,7 @@ require (
 	github.com/containers/luksy v0.0.0-20240212203526-ceb12d4fd50c
 	github.com/containers/ocicrypt v1.1.10
 	github.com/containers/storage v1.53.0
-	github.com/cyphar/filepath-securejoin v0.2.4
+	github.com/cyphar/filepath-securejoin v0.3.0
 	github.com/docker/distribution v2.8.3+incompatible
 	github.com/docker/docker v25.0.3+incompatible
 	github.com/docker/go-units v0.5.0
@@ -37,7 +37,7 @@ require (
 	golang.org/x/crypto v0.21.0
 	golang.org/x/exp v0.0.0-20240222234643-814bf88cf225
 	golang.org/x/sync v0.6.0
-	golang.org/x/sys v0.18.0
+	golang.org/x/sys v0.21.0
 	golang.org/x/term v0.18.0
 	sigs.k8s.io/yaml v1.4.0
 )
